package com.sample.android.alertdialog_list1;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;

public class AlertDialog_List1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    
	private LinearLayout layout;
	
	private Button button;
    private TextView tv;
    
	private AlertDialog.Builder alertdialog1;

    private static final String[] country = new String[] {"イタリア", "トルコ", "エジプト", "スエーデン"};
    private int country_item;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(0,0,0));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER); //中央寄せ
        setContentView(layout); //レイアウトの生成

        tv = new TextView(this);
        tv.setTextColor(Color.WHITE);
        tv.setTextSize(23);
        tv.setText("旅行したい国はどこですか？\n");
        layout.addView(tv, new LinearLayout.LayoutParams(WC, WC));
        
        button = new Button(this);
        button.setText("クリックして 下さい！");
        button.setOnClickListener(this);
        layout.addView(button,new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        show_Dialog("Show Dialog");
    }
    
    public void show_Dialog(String msg)
    {    
        alertdialog1 = new AlertDialog.Builder(this);
        alertdialog1.setIcon(R.drawable.fujisan1);  //AlertDialogに表示する「icon」を指定する
        alertdialog1.setTitle("旅行したい国を選択して下さい！\n");  //AlertDialogの上端に表示されるタイトル
        //alertdialog1.setMessage("下の適当なButtonをクリックして下さい！");  //エラー  Listメニューが表示されない！

    	alertdialog1.setItems(country, new DialogInterface.OnClickListener()
    	{  
           public void onClick(DialogInterface dialog, int item)
           {  
        	   country_item = item;
        	   tv.setText(String.format("[ %s ] に行きたいです！\n",country[item])); 
           }  
        });
    	
    	alertdialog1.setPositiveButton("YES", new DialogInterface.OnClickListener()
        {
           // この中に「"YES"」時の処理をいれる。
            public void onClick(DialogInterface dialog, int whichButton)
            {
               tv.setTextColor(Color.RED);
               tv.setText(String.format("[ %s ] に、行きたいです！\n",country[country_item]));
         	   layout.setBackgroundColor(Color.rgb(0,255,255));
            }
        });

    	alertdialog1.setNegativeButton("NO", new DialogInterface.OnClickListener()
        {
           // この中に「"NO"」時の処理をいれる。
            public void onClick(DialogInterface dialog, int whichButton)
            {
               tv.setTextColor(Color.BLACK);
               tv.setText(String.format("[ %s ] には、行きたくないです！\n",country[country_item]));
         	   layout.setBackgroundColor(Color.rgb(255,255,0));
            }
        });
    	
        alertdialog1.create(); //Dialogの生成
        alertdialog1.show();   //Dialogの表示
    }
}