package com.sample.android.alertdialog_radiobutton1;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;

public class AlertDialog_RadioButton1 extends Activity  implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    
	private LinearLayout layout;
	
	private Button button;
    private TextView tv;
    
	private AlertDialog.Builder alertdialog1;

    private static final String[] fruits = new String[] {"What Food ?", "寿司", "刺身", "天婦羅", "ウナギ"};
    private String result_item = "";
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(0,0,0));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER); //中央寄せ
        setContentView(layout);

        tv = new TextView(this);
        tv.setTextColor(Color.WHITE);
        tv.setTextSize(23);
        tv.setText("何が好きですか？\n");
        layout.addView(tv, new LinearLayout.LayoutParams(WC, WC));
        
        button = new Button(this);
        button.setText("クリックして 下さい！");
        button.setOnClickListener(this);
        layout.addView(button,new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        show_Dialog("Show Dialog");
    }
    
    public void show_Dialog(String msg)
    {    
    	int set_index = 0;
    	result_item = fruits [set_index]; 

        alertdialog1 = new AlertDialog.Builder(this);
        alertdialog1.setIcon(R.drawable.icon);
        alertdialog1.setTitle("好きなものを選択して下さい！\n");  //AlertDialogの上端に表示されるタイトル
        //alertdialog1.setMessage("下の適当なButtonをクリックして下さい！");  //エラー  Buttonメニューが表示されない！

        alertdialog1.setSingleChoiceItems(fruits ,set_index, new DialogInterface.OnClickListener()
        {           
        		public void onClick(DialogInterface dialog, int which)
        		{            
        		   result_item = fruits [which]; 
        		   tv.setText(String.format("[ %s ] が好きです！\n",fruits [which])); 
        		}
        });
        
    	alertdialog1.setPositiveButton("YES", new DialogInterface.OnClickListener()
        {
            public void onClick(DialogInterface dialog, int whichButton)
            {
               tv.setTextColor(Color.RED);
               tv.setText(String.format("[ %s ] が、好きです！\n",result_item));
         	   layout.setBackgroundColor(Color.rgb(0,255,255));
            }
        });
    	
    	alertdialog1.setNegativeButton("NO", new DialogInterface.OnClickListener()
        {
            public void onClick(DialogInterface dialog, int whichButton)
            {
               tv.setTextColor(Color.BLACK);
               tv.setText(String.format("[ %s ] は、嫌いです！\n",result_item));
         	   layout.setBackgroundColor(Color.rgb(255,255,0));
            }
        });

        alertdialog1.create(); //Dialogの生成
        alertdialog1.show();   //Dialogの表示
    }
}