package com.sample.android.alertdialog_test2;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;

public class AlertDialog_Test2 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP  = LinearLayout.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;

	private Button button;
    private TextView tv;

	private AlertDialog.Builder alertdialog1;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(0,0,0));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER); //中央寄せ
        setContentView(layout);

        tv = new TextView(this);
        tv.setTextSize(20f);
        tv.setTextColor(Color.RED);
        tv.setText("Dialog が表示されたあと、適当なButtonを選択して下さい！\n");
        layout.addView(tv, new LinearLayout.LayoutParams(WC, WC));
        
        button = new Button(this);
        button.setText("クリックして Dialog を開く");
        button.setOnClickListener(this);
        layout.addView(button,new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        show_Dialog("Show Dialog");
    }

    public void show_Dialog(String msg) //DialogInterface dialog, int whichButton
    {
        alertdialog1 = new AlertDialog.Builder(this);

        alertdialog1.setTitle("AlertDialog Test");  //AlertDialogの上端に表示されるタイトル
    	alertdialog1.setMessage("下の適当なButtonをクリックして下さい！");  //何らかの処理を促すためのメッセージ！

        //クリックしたときに画面を閉じるだけの場合、第2引数を「null」にします。
    	//alertdialog1.setPositiveButton("YES", null);  //event処理がないとき！
//*
        //肯定ボタンの設定
    	alertdialog1.setPositiveButton("YES", new DialogInterface.OnClickListener()
        {
           // この中に"YES"時の処理をいれる。
            public void onClick(DialogInterface dialog, int whichButton)
            {
               tv.setText("[ YES ] Button が選択されました！\n");
         	   layout.setBackgroundColor(Color.rgb(0,255,255));  //画面の背景色を変える
            }
        });

        //中立ボタンの設定
    	alertdialog1.setNeutralButton("中立", new DialogInterface.OnClickListener()
        {
           // この中に"中立"時の処理をいれる。
            public void onClick(DialogInterface dialog, int whichButton) {
               tv.setText("[ 中立 ] Button が選択されました！\n");
         	   layout.setBackgroundColor(Color.rgb(255,255,255));  //画面の背景色を変える
            }
        });

    	//否定ボタンの設定
    	alertdialog1.setNegativeButton("NO", new DialogInterface.OnClickListener()
        {
           // この中に"NO"時の処理をいれる。
            public void onClick(DialogInterface dialog, int whichButton)
            {
            	tv.setText("[ NO ] Button が選択されました！\n");
         	   layout.setBackgroundColor(Color.rgb(255,255,0));  //画面の背景色を変える
            }
        });
//*/
        alertdialog1.create(); //Dialogの生成
        alertdialog1.show();   //Dialogの表示
    }
}