package com.sample.android.button_relativelayout1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.TextView;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.view.ViewGroup;
import android.view.View;

public class Button_RelativeLayout1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

    //Button
    private Button button1;
    private Button button2;
    private Button button3;
    private Button button4;
    private Button button5;

	//TextView
	private TextView t_view1;  //TextView
	private TextView t_view2;  //TextView
	private TextView t_view3;  //TextView
	private TextView t_view4;  //TextView
	private TextView t_view5;  //TextView

    //レイアウトの生成
	private RelativeLayout relativeLayout;
	private RelativeLayout.LayoutParams param10;
	private RelativeLayout.LayoutParams param20;
	private RelativeLayout.LayoutParams param30;
	private RelativeLayout.LayoutParams param40;
	private RelativeLayout.LayoutParams param50;

    private int count1 = 0;
    private int count2 = 0;
    private int count3 = 0;
    private int count4 = 0;
    private int count5 = 0;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //RelativeLayout レイアウトの生成
        relativeLayout = new RelativeLayout(this);
        setContentView(relativeLayout);

//「上」「ABOVE」
        button1 = new Button(this);
        button1.setId(1);  //「 ID = 1」
        button1.setText("上");
        button1.setTextColor(Color.YELLOW);
        button1.setTextSize(20.0f);
        button1.setTypeface(null, 1); //setTypeface(null,Typeface.BOLD);
        button1.setOnClickListener(this);

        RelativeLayout.LayoutParams param1 = createParam(WC, WC);
        param1.addRule(RelativeLayout.ABOVE, 2); //「2中央の上」
        param1.addRule(RelativeLayout.CENTER_HORIZONTAL, 2);
        param1.addRule(RelativeLayout.CENTER_VERTICAL, 2);

        relativeLayout.addView(button1, param1);

//「中央」「CENTER_IN_PARENT」
        button2 = new Button(this);
        button2.setId(2);  //「 ID = 2」
        button2.setText("中央");
        button2.setTextColor(Color.RED);
        button2.setTextSize(20.0f);
        //button2.setTypeface(null,Typeface.BOLD_ITALIC);  //参考
        //button2.setTypeface(null,Typeface.BOLD | Typeface.ITALIC);  //参考
        button2.setTypeface(null, 1);
        button2.setOnClickListener(this);
        
        RelativeLayout.LayoutParams param2 = createParam(WC, WC);
        param2.addRule(RelativeLayout.CENTER_IN_PARENT, 2); //「2画面の中央」
        //param2.addRule(RelativeLayout.CENTER_HORIZONTAL, 2);  //参考
        //param2.addRule(RelativeLayout.CENTER_VERTICAL, 2);  //参考
        relativeLayout.addView(button2, param2);

//「下」「BELOW」
        button3 = new Button(this);
        button3.setId(3);  //「 ID = 3」
        button3.setText("下");
        button3.setTextColor(Color.YELLOW);
        button3.setTextSize(20.0f);
        button3.setTypeface(null, 1);
        button3.setOnClickListener(this);
        
        RelativeLayout.LayoutParams param3 = createParam(WC, WC);
        param3.addRule(RelativeLayout.BELOW, 2);  //「2中央の下」
        param3.addRule(RelativeLayout.CENTER_HORIZONTAL, 2);
        param3.addRule(RelativeLayout.CENTER_VERTICAL, 2);

        relativeLayout.addView(button3, param3);

//「左」「LEFT_OF」
        button4 = new Button(this);
        button4.setId(4);  //「 ID = 4」
        button4.setText("左");
        button4.setTextColor(Color.BLUE);
        button4.setTextSize(20.0f);
        button4.setTypeface(null, 1);
        button4.setOnClickListener(this);
        
        RelativeLayout.LayoutParams param4 = createParam(WC, WC);
        param4.addRule(RelativeLayout.LEFT_OF, 2);    //「2中央の左」
        param4.addRule(RelativeLayout.CENTER_VERTICAL, 2);

        relativeLayout.addView(button4, param4);

//「右」「LEFT_OF」
        button5 = new Button(this);
        button5.setId(5);  //「 ID = 5」
        button5.setText("右");
        button5.setTextColor(Color.BLUE);
        button5.setTextSize(20.0f);
        button5.setTypeface(null, 1);
        button5.setOnClickListener(this);
        
        RelativeLayout.LayoutParams param5 = createParam(WC, WC);
        param5.addRule(RelativeLayout.RIGHT_OF, 2);    //「2中央の右」
        param5.addRule(RelativeLayout.CENTER_VERTICAL, 2);

        relativeLayout.addView(button5, param5);
    }

    private RelativeLayout.LayoutParams createParam(int w, int h){
        return new RelativeLayout.LayoutParams(w, h);
    }

  //ボタンクリックイベントの処理
    public void onClick(View view1) {

		//button1 上
        if (view1 == button1) {
        	count1++;
        	t_view1 = new TextView(this);
        	t_view1.setId(10);  //「 ID = 10」
        	t_view1.setBackgroundColor(Color.BLACK);
        	t_view1.setTextColor(Color.YELLOW);
            t_view1.setTextSize(20.0f);
            t_view1.setTypeface(null, 1);
        	t_view1.setText("上 BUTTON1 CLICK：" + count1);

            button1.setText("上：" + count1);

        	//RelativeLayout.LayoutParams
        	param10 = createParam(WC, WC);
        	param10.addRule(RelativeLayout.ALIGN_PARENT_TOP, 10);  //「画面の上端」
        	param10.addRule(RelativeLayout.CENTER_HORIZONTAL, 10);
        	relativeLayout.addView(t_view1, param10);
        	//relativeLayout.setBackgroundColor(Color.rgb(255,255,0));  //参考
        }
        //button2 中央
        else if (view1 == button2) {
        	count2++;
        	t_view2 = new TextView(this);
        	t_view2.setId(20);  //「 ID = 20」
        	t_view2.setBackgroundColor(Color.BLACK);
        	t_view2.setTextColor(Color.RED);
            t_view2.setTextSize(20.0f);
            t_view2.setTypeface(null, 1);
        	t_view2.setText("中央：" + count2);

            button2.setText("中央：" + count2);

        	//RelativeLayout.LayoutParams
        	param20 = createParam(WC, WC);  //「幅」,「高さ」
        	param20.addRule(RelativeLayout.ABOVE, 1); //「1上Buttonの上」
        	param20.addRule(RelativeLayout.CENTER_HORIZONTAL, 1);
        	relativeLayout.addView(t_view2, param20);
        	//relativeLayout.setBackgroundColor(Color.rgb(255,255,0));  //参考
        }
        //button3 下
        else if (view1 == button3) {
        	count3++;
        	t_view3 = new TextView(this);
        	t_view3.setId(30);  //「 ID = 30」
        	t_view3.setBackgroundColor(Color.BLACK);
        	t_view3.setTextColor(Color.YELLOW);
            t_view3.setTextSize(20.0f);
            t_view3.setTypeface(null, 1);
        	t_view3.setText("下 BUTTON3 CLICK：" + count3);

            button3.setText("下：" + count3);

        	//RelativeLayout.LayoutParams
        	param30 = createParam(WC, WC);  //「幅」,「高さ」
        	param30.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM, 30);  //「画面の下端」
        	param30.addRule(RelativeLayout.CENTER_HORIZONTAL, 30);

        	relativeLayout.addView(t_view3, param30);
        }
        //button4 左
        else if (view1 == button4) {
        	count4++;
        	t_view4 = new TextView(this);
        	t_view4.setId(40);  //「 ID = 40」
            //t_view4.setTextSize(20.0f);  //参考
        	//t_view4.setTextColor(Color.BLUE);  //参考
            t_view4.setTypeface(null, 1);
        	t_view4.setBackgroundColor(Color.BLACK);
        	t_view4.setText("左ボタン：" + count4);

            button4.setText("左：" + count4);

        	//RelativeLayout.LayoutParams
        	param40 = createParam(WC, WC);  //「幅」,「高さ」
        	param40.addRule(RelativeLayout.ALIGN_PARENT_LEFT, 40);  //「画面の左端」LEFT_OF
        	param40.addRule(RelativeLayout.CENTER_VERTICAL, 40);

        	relativeLayout.addView(t_view4, param40);
        	relativeLayout.setBackgroundColor(Color.rgb(0,255,255));  //参考
        }
        //button5 右
        else if (view1 == button5) {
        	count5++;
        	t_view5 = new TextView(this);
        	t_view5.setId(50);  //「 ID = 50」
        	t_view5.setTypeface(null, 1);
        	t_view5.setBackgroundColor(Color.BLACK);
        	t_view5.setText("右ボタン：" + count5);

            button5.setText("右：" + count5);

        	//RelativeLayout.LayoutParams
        	param50 = createParam(WC, WC);  //「幅」,「高さ」
        	param50.addRule(RelativeLayout.ALIGN_PARENT_RIGHT, 50);  //「画面の右端」
        	param50.addRule(RelativeLayout.CENTER_VERTICAL, 50);

        	relativeLayout.addView(t_view5, param50);
        	relativeLayout.setBackgroundColor(Color.rgb(255,255,0));  //参考
        }
    }
}