package com.sample.android.button_test1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View.OnClickListener; //匿名内部クラスを使用するとき必要

public class Button_Test1 extends Activity implements View.OnClickListener{

	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private final static int MP = LinearLayout.LayoutParams.MATCH_PARENT;
	//private final static int FP = LinearLayout.LayoutParams.FILL_PARENT;
	
    private Button      button1;     //ボタン
    private Button      button2;     //ボタン
    private ImageButton image_button1; //イメージボタン
    private TextView textview1;
    private TextView textview2;
    private TextView textview3;
    private int count = 0;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //requestWindowFeature(Window.FEATURE_NO_TITLE); //タイトルを表示しない

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        
        layout.setBackgroundColor(Color.rgb(0,0,0));  //画面の背景色
        layout.setOrientation(LinearLayout.VERTICAL); //垂直方向に配置
        //layout.setOrientation(LinearLayout.HORIZONTAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);

        textview1 = new TextView(this); //TextViewクラスのオブジェクトを宣言する
        textview1.setTextSize(20.0f);  //フォントサイズ
        textview1.setTextColor(Color.rgb(255,0,0));  //フォントカラー
        
        //設定したlayoutにTextViewを追加する
        layout.addView(textview1, new LinearLayout.LayoutParams(WC, WC));
        
        textview2 = new TextView(this); //TextViewクラスのオブジェクトを宣言する
        textview2.setTextSize(25.0f);  //フォントサイズ
        textview2.setTextColor(Color.YELLOW);  //フォントカラー
        
        //layoutにTextViewを追加する
        layout.addView(textview2, new LinearLayout.LayoutParams(WC, WC));
        
        textview3 = new TextView(this); //TextViewクラスのオブジェクトを宣言する
        textview3.setTextSize(30.0f);   //フォントサイズ
        textview3.setTextColor(Color.BLUE);  //フォントカラー
        
        //layoutにTextViewを追加する
        layout.addView(textview3, new LinearLayout.LayoutParams(WC, WC));
        
        //ボタンの生成(1)
        button1 = new Button(this);
        button1.setBackgroundColor(Color.rgb(255,0,0));
        button1.setText("ボタン1");

        button1.setOnClickListener(new OnClickListener()  //匿名内部クラス
        {
        	public void onClick(View v) 
        	{
        		textview1.setText("Hello 片山　幸雄！");
        	}
        });

        //ボタンの生成(2)
        button2 = new Button(this);
        button2.setTextColor(Color.BLACK);
        button2.setBackgroundColor(Color.YELLOW);
        button2.setText("クリックを繰り返して下さい！");

        button2.setOnClickListener(new OnClickListener()  //匿名内部クラス
        {
        	public void onClick(View v) 
        	{
        		textview2.setText("カウント = " + Integer.toString(count++));
        	}
        });
        
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));
        layout.addView(button2, new LinearLayout.LayoutParams(MP, WC));
        
        //画像の読み込み
        Bitmap bitmap1 = BitmapFactory.decodeResource( getResources(),R.drawable.fujisan1);

        //イメージボタンの生成(3)
        image_button1= new ImageButton(this);
        image_button1.setBackgroundColor(Color.BLUE);
        
        image_button1.setImageBitmap(bitmap1);
        image_button1.setOnClickListener(this);  //イベント・リスナーの登録
        
        layout.addView(image_button1, new LinearLayout.LayoutParams(WC, WC));
    }
    
    //ボタンのクリックイベントの処理
    public void onClick(View view)
    {
        //イメージボタンを押した時の処理
        if(view == image_button1)
        {
        	textview3.setText("Hello 片山　百合子！");
        }
    }
}