package com.sample.android.edittext1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.view.View;
import android.widget.EditText;
import android.widget.Button;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.graphics.Typeface;

public class EditText1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout;

	private Button button;
    private TextView textview1;
    private TextView textview2;
    private EditText edit1;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(0,0,0));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER); //中央寄せ
        setContentView(layout); //レイアウトの生成//

        textview1 = new TextView(this);
        textview1.setText("TextView の表示エリア");
        textview1.setTextSize(20f);
        textview1.setTextColor(Color.YELLOW);
        textview1.setTypeface(null,Typeface.BOLD);
        layout.addView(textview1, new LinearLayout.LayoutParams(WC, WC));
        
        textview2 = new TextView(this);
        textview2.setText("メッセージを入力した後、[Click]して下さい！");
        textview2.setTextSize(15f);
        textview2.setTextColor(Color.YELLOW);
        textview2.setTypeface(null,Typeface.BOLD);
        textview2.setPadding(0, 10, 0, 10);  //int left, int top, int right, int bottom
        layout.addView(textview2, new LinearLayout.LayoutParams(WC, WC));
        
        button = new Button(this);
        button.setText("Click");
        button.setTextSize(20f);
        button.setTextColor(Color.BLUE);
        button.setTypeface(null,Typeface.BOLD);
        button.setOnClickListener(this);
        button.setPadding(10, 0, 10, 0);  //int left, int top, int right, int bottom
        layout.addView(button,new LinearLayout.LayoutParams(WC, WC));
        
        edit1 = new EditText(this);
        edit1.setText("文字の入力エリア"); //文字の入力エリア
        edit1.setTextSize(20f);
        edit1.setTextColor(Color.RED);
        layout.addView(edit1, new LinearLayout.LayoutParams(WC, WC));
        
        textview1.setVerticalScrollBarEnabled(true);
        textview1.setScrollContainer(true);
        textview1.setScrollBarStyle(BIND_AUTO_CREATE);

        //edit1.setSingleLine(True);
        edit1.setMaxLines(2);  //最大の表示行数
        //edit1.setMaxEms(5);  //1行に表示する最大の文字数
        edit1.setHorizontallyScrolling(true);
        
        edit1.setVerticalScrollBarEnabled(true);
        edit1.setScrollContainer(true);
        edit1.setScrollBarStyle(BIND_AUTO_CREATE); //SCROLLBARS_OUTSIDE_INSET
        edit1.setScrollContainer(true);
    }
    
    public void onClick(View v)
    {
    	textview1.setText(edit1.getText() );
    }
}