package com.sample.android.graphics_test1;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.Typeface;

public class Graphics_Test1 extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(new Graphics_Show1(this) ); //Viewクラスを呼ぶ
    }
}
    class Graphics_Show1 extends View 
    {
    	public Graphics_Show1(Context context)  //コンストラクタ
    	{
    	   super(context);
    	   setBackgroundColor(Color.YELLOW);
        }
    	
    	protected void onDraw(Canvas canvas)
    	{
	    	canvas.drawColor(Color.BLACK); //Canvaの背景色
	    	Paint paint = new Paint();
	    	
	    	paint.setColor(Color.RED);
	    	paint.setStrokeWidth(5);
	    	paint.setAntiAlias(true);

	    	//線で円を描く
	        paint.setColor(Color.argb(255,255,0,0));
	    	paint.setStyle(Paint.Style.STROKE);
	    	canvas.drawCircle(50, 50, 30, paint);
	    	
	    	//円の内部を塗りつぶす
	    	paint.setStyle(Paint.Style.FILL);
	    	canvas.drawCircle(150, 50, 30, paint);
	    	
	       //楕円の内部を塗りつぶす
	    	RectF rect = new RectF(200, 20, 300, 80);
		    paint.setStyle(Paint.Style.FILL);
		    canvas.drawOval(rect, paint);
//
		    //四角形の描画
	        paint.setStyle(Paint.Style.STROKE); //float left, float top, float right, float bottom
	        paint.setColor(Color.argb(255,0,255,0));
	        canvas.drawRect(new Rect(10,110,90,170),paint);
	        
		    //半円の描画
	        RectF oval3 = new RectF(110, 100, 190, 180.0f);
	        canvas.drawArc(oval3, 0, 180, true, paint);  //「0度」～「180度

	        //四角形の塗り潰し
	        paint.setStyle(Paint.Style.FILL_AND_STROKE);
	        canvas.drawRect(new Rect(110+100,110,190+100,170),paint);
	        
	        //「0度」～「270度」の塗りつぶしの円の描画
	        canvas.drawArc(oval3, 0, 270, true, paint);  //「0度」～「270度
//
	        //角丸矩形の描画
	        paint.setStyle(Paint.Style.STROKE);
	        paint.setColor(Color.argb(255,0,0,255));
	        canvas.drawRoundRect(new RectF(10,200,90,270),20,20,paint);

		    // 三角形の描画
		    paint.setStyle(Paint.Style.STROKE);
		    Path path1 = new Path();
		    int y = 100;
		    path1.moveTo(160, 100 + y);
		    path1.lineTo(110, 170 + y);
		    path1.lineTo(210, 170 + y);
		    path1.lineTo(160, 100 + y);
		    canvas.drawPath(path1, paint);
	        
	        //角丸矩形の塗り潰し
	        paint.setStyle(Paint.Style.FILL);
	        canvas.drawRoundRect(new RectF(110 + y,100 + y,190 + y,170 + y),20,20,paint);
//
	        //Pathに沿って文字を書く
	        paint.setColor(Color.RED);
	        paint.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
	        paint.setTextSize(20);
	        paint.setStrokeWidth(5);
	        int y1 = 105;
	        
	        Path path = new Path();
	        path.moveTo(20 + y1, 200 + y1);
	        path.lineTo(100 + y1, 200 + y1);
	        path.lineTo(100 + y1, 240 + y1);
	        path.lineTo(20 + y1, 240 + y1);
	        canvas.drawTextOnPath("Robert thank you for your offer to visit Germany !", path, 0, -5, paint);  //0,0
    	}
    }