package com.sample.android.key_test2;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.KeyEvent;

public class Key_Test2 extends Activity {
    /** Called when the activity is first created. */
	private KeyIn_Show  keyin_obj;    //KeyIn_Showクラス のオブジェクトの宣言

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        keyin_obj = new KeyIn_Show(this); //KeyIn_Showクラスを呼ぶ為のクラスオブジェクト
        setContentView(keyin_obj);
    }
}

//Keyイベントの処理クラス
class KeyIn_Show extends View
{
	private int keyin_code = -999; //デフォルトで、存在しないキー値を設定
	private String in_key = "";

	private int x = getWidth() / 2;
	private int y = getHeight() / 2;

	private static final int CIRCLE = 10;
	private static final int MOVE = 10;

	KeyIn_Show(Context context)  //コンストラクタ
	{
	   super(context);
	   setFocusable(true);  //フォーカスの指定
	   setFocusableInTouchMode(true);  //タッチモードのフォーカスの指定

	   setBackgroundColor(Color.rgb(255,255,0));  //画面の背景の色
	}

	//KeyDownのときのイベント処理
	public boolean onKeyDown(int keyCode, KeyEvent event)
	{
	    keyin_code = keyCode;

		//画面の「左」「右」「上」「下」の端を超えた時の「円」の移動範囲の制限
		if(x <= 0 ){ x = 3; }

		if( x >= getWidth()){ x = x - 10; }

		if(y <= 0 ){ y = 4; }

		if(y >= getHeight()){ y = y - 10; }

	    switch (keyin_code)
	    {
	       case KeyEvent.KEYCODE_DPAD_UP: //[↑] 上向きキー
                        y -= MOVE;
                        in_key = "KEY_UP";
                break;
	       case KeyEvent.KEYCODE_DPAD_DOWN: //[↓] 下向きキー
	                    y += MOVE;
	                    in_key = "KEY_DOWN";
	             break;
	       case KeyEvent.KEYCODE_DPAD_LEFT: //[←] 左向きキー
	                    x -= MOVE;
	                    in_key = "KEY_LEFT";
	             break;
	       case KeyEvent.KEYCODE_DPAD_RIGHT: //[→] 右向きキー
	                   x += MOVE;
	                   in_key = "KEY_RIGHT";
	             break;
	       case KeyEvent.KEYCODE_DPAD_CENTER:
	    	          x = getWidth() / 2;
	    	          y = getHeight() / 2;
	    	     break;

	       default:  break;
	    }

	     invalidate(); //ビューの再描画  必要です！
	     return true;
    }

	//KeyUpのときのイベント処理
	public boolean onKeyUp(int keyCode, KeyEvent event)
	{
		//処理
		return true;
	}

	//描画処理
	protected void onDraw(Canvas canvas)
	{
	     Paint paint1 = new Paint();

	     paint1.setAntiAlias(true);  //文字を滑らかに見せる「AntiAlias」の設定
	     paint1.setColor(Color.BLUE);
	     canvas.drawCircle(x, y, CIRCLE, paint1); //円の描画

	     paint1.setTextSize(18);
	     paint1.setColor(Color.BLACK);
	     canvas.drawText("キーインしたコード = " + keyin_code + "  " + in_key, 10, 30, paint1);

		 in_key = ""; //前のキー表示のクリア
	}
}