package com.sample.android.layout_nest9_1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;

public class Layout_Nest9_1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

	private LinearLayout linear_layout1;  //最初の大元のLayout
	private LinearLayout in_linear_layout1;  //入れ子1のLayout「Button1を上端に配置するためのLayout1」
	private LinearLayout in_linear_layout2;  //入れ子2のLayout「Button2を垂直中央に配置するためのLayout2」
	private LinearLayout in_linear_layout3;  //入れ子3のLayout「Button3を下端に配置するためのLayout3」

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

	private  LinearLayout.LayoutParams params1;  //button1
	private  LinearLayout.LayoutParams params2;  //button2
	private  LinearLayout.LayoutParams params3;  //button3

	private  LinearLayout.LayoutParams params4;  //button1
	private  LinearLayout.LayoutParams params5;  //button2
	private  LinearLayout.LayoutParams params6;  //button3

	private  LinearLayout.LayoutParams params7;  //button1
	private  LinearLayout.LayoutParams params8;  //button2
	private  LinearLayout.LayoutParams params9;  //button3

	private Button   button1;
	private Button   button2;
	private Button   button3;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
     //水平中央への配置用
        params1 = new LinearLayout.LayoutParams(WC,WC);  //Button1 上端の水平中央
        params1.gravity = Gravity.TOP | Gravity.CENTER_HORIZONTAL ;

      params2 = new LinearLayout.LayoutParams(WC,WC,1);  //第3引数に「1」を設定しないと、上端に寄せられる
      params2.gravity = Gravity.CENTER_VERTICAL | Gravity.CENTER_HORIZONTAL | Gravity.CENTER;  //Button2 垂直中央の水平中央

        params3 = new LinearLayout.LayoutParams(WC,WC);  //Button3 下端の水平中央
        params3.gravity = Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL;
        
     //左端への配置用
        params4 = new LinearLayout.LayoutParams(WC,WC);  //Button1  上端の左端
        params4.gravity = Gravity.TOP | Gravity.LEFT ;

      params5 = new LinearLayout.LayoutParams(WC,WC,1);  //第3引数に「1」を設定しないと、上端に寄せられる
      params5.gravity = Gravity.CENTER_VERTICAL | Gravity.LEFT;  //Button2 垂直中央の左端

        params6 = new LinearLayout.LayoutParams(WC,WC);  //Button3 下端の左端
        params6.gravity = Gravity.BOTTOM | Gravity.LEFT;

      //右端への配置用
        params7 = new LinearLayout.LayoutParams(WC,WC);  //Button1 上端の右端
        params7.gravity = Gravity.TOP | Gravity.RIGHT ;

      params8 = new LinearLayout.LayoutParams(WC,WC,1);  //第3引数に「1」を設定しないと、上端に寄せられる
      params8.gravity = Gravity.CENTER_VERTICAL | Gravity.RIGHT;  //Button1 垂直中央の右端

        params9 = new LinearLayout.LayoutParams(WC,WC);  //Button3 下端の右端
        params9.gravity = Gravity.BOTTOM | Gravity.RIGHT;

  //大元のLayout
   linear_layout1 = new LinearLayout(this);
   linear_layout1.setOrientation(LinearLayout.VERTICAL);  //垂直に設定
   setContentView(linear_layout1);  //１個のみ設定すること！ 最後の大元のLayoutのみ設定すること！

     //①Button1を上端に配置するためのLayout1
      in_linear_layout1 = new LinearLayout(this);
      in_linear_layout1.setOrientation(LinearLayout.VERTICAL);  //垂直に設定
	      button1 = new Button(this);  //button1の生成
	      button1.setTextColor(Color.RED);  button1.setBackgroundColor(Color.WHITE);
	      button1.setText("Button1");
	      button1.setOnClickListener(this);
	      button1.setGravity(Gravity.CENTER); //「BUTTON」に表示する文字の位置
	      //button1.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT,1));
	  in_linear_layout1.addView(button1, new LinearLayout.LayoutParams(WC, WC)); //「in_linear_layout1」に「button1)」を載せる

      //②Button2を垂直中央に配置するためのLayout2
	   in_linear_layout2 = new LinearLayout(this);
	   in_linear_layout2.setOrientation(LinearLayout.VERTICAL);  //
	   in_linear_layout2.setGravity(Gravity.CENTER_VERTICAL );  //垂直の中央に設定
	   //in_linear_layout2.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT,1));
          button2 = new Button(this);  //button2の生成
          button2.setTextColor(Color.RED);  button2.setBackgroundColor(Color.WHITE);
          button2.setText("Button2");
          button2.setOnClickListener(this);
          button2.setGravity(Gravity.CENTER);
          
       //次の行をコメント「//」にすると、BUTTONが上端と下端にのみ表示される
       in_linear_layout2.addView(button2); //「in_linear_layout2」に「button2」を載せる

     //③Button3を下端に配置するためのLayout3
       in_linear_layout3 = new LinearLayout(this);
       in_linear_layout3.setOrientation(LinearLayout.VERTICAL);  //垂直に設定
          button3 = new Button(this); //button3の生成
          button3.setTextColor(Color.RED);  button3.setBackgroundColor(Color.WHITE);
          button3.setText("Button3");
          button3.setOnClickListener(this);
          button3.setGravity(Gravity.CENTER);
       in_linear_layout3.addView(button3); //「in_linear_layout3」に「button3」を載せる
//*  水平の中央に配置       
      linear_layout1.addView(in_linear_layout1, params1);  //「linear_layout1」に「in_linear_layout1」を載せる
      linear_layout1.addView(in_linear_layout2, params2);  //button2 「weight = 1」
      linear_layout1.addView(in_linear_layout3, params3);  //button3
//*/
/*   左端に配置
      linear_layout1.addView(in_linear_layout1, params4);  //「linear_layout1」に「in_linear_layout1」を載せる
      linear_layout1.addView(in_linear_layout2, params5);  //button2 「weight = 1」
      linear_layout1.addView(in_linear_layout3, params6);  //button3
*/
/*   右端に配置
      linear_layout1.addView(in_linear_layout1, params7);  //「linear_layout1」に「in_linear_layout1」を載せる
      linear_layout1.addView(in_linear_layout2, params8);  //button2 「weight = 1」
      linear_layout1.addView(in_linear_layout3, params9);  //button3
*/
    }

    public void onClick(View view)
    {
      if(view == button1)
      {
         //処理
      }
    }
}
