package com.sample.android.layout_nest9_6;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;

public class Layout_Nest9_6 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	//private final int WEIGHT = ViewGroup.LayoutParams.;
	
	private LinearLayout linear_layout1;  //大元のLayout

	private LinearLayout in_linear_layout1;  //上端の水平方向のButton用のLayout1
	private LinearLayout in_linear_layout2;  //中央の水平方向の3個のButton用のLayout2
	private LinearLayout in_linear_layout3;  //下端の水平方向のButton用のLayout3

	private  LinearLayout.LayoutParams params2;  //上端のLayout用パラメータ

	private  LinearLayout.LayoutParams params4;  //中央のLayout用パラメータ
	private  LinearLayout.LayoutParams params5;
	private  LinearLayout.LayoutParams params6;

	private  LinearLayout.LayoutParams params8;  //下端のLayout用パラメータ
	
	private Button   button2;  //上端

	private Button   button4;  //中央
	private Button   button5;
	private Button   button6;

	private Button   button8;  //下端

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
/*  上端 **********************************************************************  */
        params2 = new LinearLayout.LayoutParams(WC,WC);
     params2.gravity = Gravity.TOP | Gravity.CENTER; //上端の中央

/*  中央  **********************************************************************  */
        params4 = new LinearLayout.LayoutParams(WC,WC,1);
        params4.gravity = Gravity.CENTER_VERTICAL | Gravity.LEFT ;  //中央の左

      params5 = new LinearLayout.LayoutParams(WC,WC,1);  //中央 第3引数に「1」を設定
      params5.gravity = Gravity.CENTER_VERTICAL | Gravity.CENTER;  //中央の中央
      params5.setMargins(25, 0, 25, 0);  //int left, int top, int right, int bottom

        params6 = new LinearLayout.LayoutParams(WC,WC,1);
        params6.gravity = Gravity.CENTER_VERTICAL | Gravity.RIGHT;   //中央の右
//
/*  下端 **********************************************************************  */
      params8 = new LinearLayout.LayoutParams(WC,WC);
      params8.gravity = Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL ; //下端の中央

/*  大元のLayout  ****************************************************  */
   linear_layout1 = new LinearLayout(this);
   linear_layout1.setOrientation(LinearLayout.VERTICAL);  //垂直方向のLayout
   setContentView(linear_layout1,new LinearLayout.LayoutParams(MP,MP));  //大元のLayoutのみ設定する

 /*  上端の内部 Layout1 ****************************************************  */
   in_linear_layout1 = new LinearLayout(this);
   in_linear_layout1.setOrientation(LinearLayout.HORIZONTAL);  //水平方向のLayout1
   in_linear_layout1.setLayoutParams(new LinearLayout.LayoutParams(MP,WC));
   in_linear_layout1.setGravity(Gravity.CENTER_HORIZONTAL);  //「in_layout」 の中央寄せ
	   button2 = new Button(this);  //上の中央ボタンの生成
	   button2.setTextColor(Color.RED);;  button2.setBackgroundColor(Color.WHITE);
	   button2.setText("Button2");
	   button2.setOnClickListener(this);
	   button2.setGravity(Gravity.CENTER);
    in_linear_layout1.addView(button2, params2); //上端の中央に配置

 /*  中央の内部 Layout2  ************************************************  */
	   in_linear_layout2 = new LinearLayout(this);
	   in_linear_layout2.setOrientation(LinearLayout.HORIZONTAL);  //水平方向の3個のButton用のLayout2
	   in_linear_layout2.setLayoutParams(new LinearLayout.LayoutParams(MP, WC,1));  //注意！「weight = "1"」
	      button4 = new Button(this);  //中央の左
	      button4.setTextColor(Color.RED);;  button4.setBackgroundColor(Color.WHITE);
	      button4.setText("Button4");
	      button4.setOnClickListener(this);
	      button4.setGravity( Gravity.CENTER);
	   in_linear_layout2.addView(button4, params4);  //中央の左端に配置

	       button5 = new Button(this);
	       button5.setTextColor(Color.RED);;  button5.setBackgroundColor(Color.WHITE);
	       button5.setText("Button5");
	       button5.setOnClickListener(this);
	       button5.setGravity(Gravity.CENTER);
		in_linear_layout2.addView(button5, params5);  //中央の中央に配置

	        button6 = new Button(this);
	        button6.setTextColor(Color.RED);;  button6.setBackgroundColor(Color.WHITE);
	        button6.setText("Button6");
	        button6.setOnClickListener(this);
	        button6.setGravity(Gravity.CENTER);
		 in_linear_layout2.addView(button6, params6);  //中央の右端に配置

 /*  下端の内部 Layout3   ****************************************  */
		   in_linear_layout3 = new LinearLayout(this);
		   in_linear_layout3.setOrientation(LinearLayout.HORIZONTAL);  //水平方向のLayout1
		   in_linear_layout3.setGravity(Gravity.CENTER_HORIZONTAL);  //「in_layout」 の中央寄せ
	          button8 = new Button(this); //中央ボタンの生成
	          button8.setTextColor(Color.RED);;  button8.setBackgroundColor(Color.WHITE);
	          button8.setText("Button8");
	          button8.setOnClickListener(this);
	          button8.setGravity(Gravity.CENTER);
			in_linear_layout3.addView(button8, params8); //下端の中央に配置

      /*  表示する部分  ********************************************************* */
       linear_layout1.addView(in_linear_layout1); //上端の水平方向の表示
       linear_layout1.addView(in_linear_layout2); //中央の水平方向の表示
       linear_layout1.addView(in_linear_layout3); //下端の水平方向の表示
    }

    public void onClick(View view)
    {
      if(view == button2)
      {
          //処理
      }
    }
}
