package com.sample.android.listview_test5;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class ListView_Test5 extends Activity {
    /** Called when the activity is first created. */

    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout1;

	private TextView tv1;

	private String[] array_data1 = {"北海道", "宮城県","沖縄県","愛知県","愛媛県","群馬県","島根県"};
	private String[] array_data2 = {"札幌", "仙台","那覇","名古屋","松山","前橋","松江"};

	private ArrayAdapter<String> array_adapter;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

		    layout1=new LinearLayout(this);
		    layout1.setBackgroundColor(Color.rgb(255,255,0));
		    layout1.setOrientation(LinearLayout.VERTICAL);
		    layout1.setGravity(Gravity.CENTER);
		    setContentView(layout1); //必要ッです！レイアウトの生成

		    tv1 = new TextView(this);
		    tv1.setText("各県の県庁所在地\n");
		    tv1.setTextColor(Color.BLUE);
		    tv1.setTextSize(20);
		    layout1.addView(tv1, new LinearLayout.LayoutParams(WC, WC));
		//
		    ListView list  = new ListView(this);
		    list.setItemsCanFocus(false);
		    list.setTextFilterEnabled(true);
		    list.setBackgroundColor(Color.BLACK);
		    list.setCacheColorHint(Color.BLUE);  //ドラッグするときの色
		    list.setDrawingCacheBackgroundColor(Color.RED);
		    layout1.addView(list,new LinearLayout.LayoutParams(WC, WC));
	
		    //ArrayAdapter を作成
		    //array_adapter = new ArrayAdapter<String>(this, R.layout.item_attribute,);  //add("韓国")を使うとき！
		    array_adapter = new ArrayAdapter<String>(this, R.layout.item_attribute, array_data1); //文字列配列array_data1
		/*
		    array_adapter.add("韓国");  //arrayAdapter.
		    array_adapter.add("中国");
		    array_adapter.add("イタリア");
		    array_adapter.add("フランス");
		    array_adapter.add("イギリス");
		    array_adapter.add("ドイツ");
		    array_adapter.add("日本");
		*/
		    //ListView に Adapter を設定
		    list.setAdapter(array_adapter);
		    list.setSelection(2);  //Listの「第3」項目を「on」にセット

		     //ListView の項目がクリックされた時に呼び出されるコールバックを登録
		    list.setOnItemClickListener(new Clicked_Item_Detected());
		}
		
		//ListのItemのクリックされたときのイベント処理をするクラス
		class Clicked_Item_Detected implements OnItemClickListener
		{
		    public void onItemClick( AdapterView<?> parent, View view, int position, long id)
		    {
		        TextView list_textview = (TextView)view;
		        tv1.setText( list_textview.getText() + " の県庁所在地は\n[ " + array_data2[position] + " ] です！\n");
		    }
		}
}