package com.sample.android.menu_test4;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.graphics.Color;

public class Menu_Test4 extends Activity {
    /** Called when the activity is first created. */
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private LinearLayout layout1;

	private TextView tv1;

	private static final int MAIN = 0;
	private static final int MENU_ITEM_ID0 = 0;
	private static final int MENU_ITEM_ID1 = 1;
	private static final int MENU_ITEM_ID2 = 2;
	private static final int MENU_ITEM_ID3 = 3;
	private static final int MENU_ITEM_ID4 = 4;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //「ACTION_BAR」(アクション・バー)を有効にする
        getWindow().requestFeature(Window.FEATURE_ACTION_BAR);  //

        layout1=new LinearLayout(this);
        layout1.setBackgroundColor(Color.rgb(0,0,0));
        layout1.setOrientation(LinearLayout.VERTICAL);
        layout1.setGravity(Gravity.TOP);
        setContentView(layout1);

        tv1 = new TextView(this);
        tv1.setText("\n操作画面の「MENU」ボタンをクリックして下さい！");
        tv1.setTextSize(20);
        tv1.setTextColor(Color.WHITE);
        layout1.addView(tv1, new LinearLayout.LayoutParams(WC, WC));
    }

    //オプション・メニューが最初に呼び出される時に、1度だけ呼び出されます
    public boolean onCreateOptionsMenu(Menu menu)
    {
       super.onCreateOptionsMenu(menu);

     //オプション・メニューの設定
       //int groupId, int itemId, int order, CharSequence title   //オブジェクトのカスケード(直列)接続の例
       menu.add(MAIN, MENU_ITEM_ID0, Menu.NONE, "クロップ").setShortcut('0', 'z').setIcon(android.R.drawable.ic_menu_crop);

       //1 個目の文字がテンキー 用のショートカットキー、2 個目の文字がフルキーボード用のショートカットキー
       //item0.setIcon(R.drawable.icon); //R.drawableにある自作の「icon.png」を指定  「drawable-mdpi」等はエラーとなる
       //item0.setIcon(android.R.drawable.ic_menu_month); //Androidが持っているシステムアイコン
       //http://code.google.com/android/reference/android/R.drawable.html //Androidが持っているシステムアイコンのサイト

       MenuItem item1 = menu.add(MAIN, MENU_ITEM_ID1, 0, "カメラ");
       item1.setShortcut('1', 'a');
       item1.setIcon(android.R.drawable.ic_menu_camera);

       MenuItem item2 = menu.add(MAIN, MENU_ITEM_ID2, 0, "コンパス");
       item2.setShortcut('2', 'b');
       item2.setIcon(android.R.drawable.ic_menu_compass);

     //アクション・バーへのメニューアイテム「4」の追加
       MenuItem item3 = menu.add(MAIN, MENU_ITEM_ID3, 0, "富士山");
       item3.setShortcut('3', 'c');
       item3.setIcon(R.drawable.fujisan1); //android.R.drawable.ic_menu_gallery
       //item3.setIcon(android.R.drawable.ic_menu_gallery); //android.R.drawable.ic_menu_gallery
       item3.setShowAsAction(MenuItem.SHOW_AS_ACTION_ALWAYS);
       
    //アクション・バーへのメニューアイテム「5」の追加
       MenuItem item4 = menu.add(MAIN, MENU_ITEM_ID4, 0, "熱帯魚");
       item4.setShortcut('4', 'd');
       item4.setIcon(R.drawable.fish2); //android.R.drawable.ic_menu_gallery
       //item4.setIcon(android.R.drawable.ic_menu_gallery); //android.R.drawable.ic_menu_gallery
       item4.setShowAsAction(MenuItem.SHOW_AS_ACTION_ALWAYS);  //SHOW_AS_ACTION_WITH_TEXT

       return true;  //メニューを表示するときは、「真」を返す！
    }

    public boolean onOptionsItemSelected(MenuItem item)
    {
    	int item_id = item.getItemId(); //item.getTitle();

    	switch(item_id)  //参考 item.getItemId()も可！
    	{
           case MENU_ITEM_ID0:
               Toast.makeText(this,"クロップ",Toast.LENGTH_LONG).show();
               //crop_Routine(); //処理ルーチンを呼ぶ
               do_Menu(item); //処理ルーチンを呼ぶ
               break;

          case MENU_ITEM_ID1: // 内部カメラの起動
               Toast.makeText(Menu_Test4.this, "カメラ",Toast.LENGTH_LONG).show();
                //camera_Routine(); //処理ルーチンを呼ぶ
               do_Menu(item);
                break;

          case MENU_ITEM_ID2:
               Toast.makeText(Menu_Test4.this, "コンパス",Toast.LENGTH_LONG).show();
               //compass_Routine(); //処理ルーチンを呼ぶ
               do_Menu(item);
               break;

          case MENU_ITEM_ID3:
              Toast.makeText(Menu_Test4.this, "富士山",Toast.LENGTH_LONG).show();
              //gallery_Routine(); //処理ルーチンを呼ぶ
              do_Menu(item);
              break;

          case MENU_ITEM_ID4:
              Toast.makeText(Menu_Test4.this, "熱帯魚",Toast.LENGTH_LONG).show();
              //gallery_Routine(); //処理ルーチンを呼ぶ
              do_Menu(item);
              break;

          default:
        	  break;
        }

      return true;  //動作を完結させる場合は、「真」を返す！
    }

    void do_Menu(MenuItem item)
    {
    	//String item_id = Integer.toString(item.getItemId()); //参考
    	//String item_id = Integer.toString(id); //参考
    	tv1.setText( "\n選択したのは：" + item.getTitle() + " です！");
    }
}