package com.sample.android.radiobutton_check_test1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.widget.RadioButton;
import android.widget.LinearLayout;
import android.widget.TextView;

public class RadioButton_Check_Test1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP  = LinearLayout.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;
	private LinearLayout in_layout1;
	
	private  LinearLayout.LayoutParams params; //TextViewの「Margin」設定用
	
	private RadioButton[]  radiobutton;  //RadioButtonの配列
	private int array_length = 3;
	
	private TextView  textview;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        params = new LinearLayout.LayoutParams(WC,WC);  //TextView用 
        params.setMargins(0, 10, 0, 0);  //TextViewの「上」に「10」ピクセルのMargin(余白)を設定する
        
        layout=new LinearLayout(this);  //全体および「TextView」用
        layout.setBackgroundColor(Color.rgb(0,0,0));  //画面の背景色「黒」
        layout.setOrientation(LinearLayout.VERTICAL);  //これのみだと、全て左寄せとなる！
        //layout.setGravity(Gravity.CENTER); //OK
        layout.setGravity(Gravity.TOP | Gravity.CENTER_HORIZONTAL); //上端の中央寄せ「必要！」
      //layout.setGravity(Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL); //①下端の中央寄せ「必要！」
        setContentView(layout,new LinearLayout.LayoutParams(MP,MP)); //レイアウトの生成
//
        in_layout1=new LinearLayout(this);  //RadioButton用
        in_layout1.setOrientation(LinearLayout.VERTICAL);
        //in_layout1.setGravity(Gravity.CENTER); //OK
        in_layout1.setGravity(Gravity.CENTER_VERTICAL);  //中央寄せ「必要！」
        in_layout1.setLayoutParams(new LinearLayout.LayoutParams(WC,WC,1)); //注意！「weight = "1"」
       
        textview = new TextView(this);
        textview.setText("What Button is Clicked ?");
        textview.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
        textview.setTextSize(20);
        textview.setTextColor(Color.rgb(255,255,255));
        textview.setPadding(5, 0, 5, 0); //left, top, right, bottom
        textview.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        textview.setGravity(Gravity.CENTER);
        
        radiobutton = new  RadioButton[array_length]; //BadioButton配列の生成
        
        for (int i=0; i<radiobutton.length; i++)  //BadioButtonへの各種の設定
        {
        	radiobutton[i] = new RadioButton(this);

        	radiobutton[i].setText("RadioButton-" + i + " ");  //ラベルの表示 最後の空白「" "」に注意
        	radiobutton[i].setTextColor(Color.rgb(0,0,0));  //
        	radiobutton[i].setTextSize(16);
        	radiobutton[i].setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
        	radiobutton[i].setId(i);
        	radiobutton[i].setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        	radiobutton[i].setOnClickListener(this);
        	in_layout1.addView(this.radiobutton[i]);
        }

       layout.addView(textview, params);  //画面の上端にMarginを付けて配置
       layout.addView(in_layout1);  //BadioButtonを、画面の中央に配置
      //layout.addView(textview, params);  //①画面の下端に配置するとき、最後に記述する！
    }

    public void onClick(View view)
    {
    	Integer[] color ={Color.BLUE,Color.RED,Color.YELLOW,Color.CYAN,Color.MAGENTA,Color.GRAY};  //色の配列
    	
    	String[] iro ={"青","赤","黄"};
    	
    	int checked_id;
    	
    	checked_id = view.getId(); //クリックしたRadioButtonの「ID」を取得
    	
    	 //クリックしたRadioButtonのクラス「変数」を取得
    	RadioButton radio_button = (RadioButton)findViewById(checked_id);

    	radio_button.setBackgroundColor(color[checked_id + 3]); //クリックしたRadioButtonの背景色を設定
    	
    	//RadioButton を、すべてリセットする
   	    for (int i=0; i<radiobutton.length; i++)
        {
        	 radiobutton[i].setChecked(false);
        }
        
        radio_button.setChecked(true);  //選択されたRadioButtonのみに、チェックマークを設定する
        
   	    textview.setText("RadioButton-" + checked_id + " [ " + iro[checked_id] + " ]");
   	    
        layout.setBackgroundColor(color[checked_id]);  //クリックしたRadioButtonで、画面の背景色を変える
    }
}