package com.sample.android.radiobutton_group1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.RadioButton;
import android.widget.LinearLayout;

public class RadioButton_Group1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP  = LinearLayout.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;
	private LinearLayout in_layout1;
	
	private  LinearLayout.LayoutParams params; //TextViewの「Margin」設定用
	
	private RadioButton[]  radiobutton;  //RadioButtonの配列
	private int array_length = 6;
	
	private RadioGroup radio_group;  //ラジオグループ
	
	private TextView  textview;
	
	private String[] country ={"オーストラリア","イギリス","フランス","ドイツ","イタリア","中国"};

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        params = new LinearLayout.LayoutParams(WC,WC);  //TextView用
        params.setMargins(0, 10, 0, 0);  //TextViewの「上」に「10」ピクセルのMargin(余白)を設定する
        
        layout=new LinearLayout(this);  //全体および「TextView」用
        layout.setBackgroundColor(Color.rgb(185,185,0));  //画面の背景色「黒」
        layout.setOrientation(LinearLayout.VERTICAL);  //これのみだと、全て左寄せとなる！
        //layout.setGravity(Gravity.CENTER); //OK
        layout.setGravity(Gravity.TOP | Gravity.CENTER_HORIZONTAL); //上端の中央寄せ「必要！」
        //layout.setGravity(Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL); //①下端の中央寄せ「必要！」
        setContentView(layout,new LinearLayout.LayoutParams(MP,MP)); //レイアウトの生成

        in_layout1=new LinearLayout(this);  //RadioButton用
        in_layout1.setOrientation(LinearLayout.VERTICAL);
        //in_layout1.setGravity(Gravity.CENTER); //OK
        in_layout1.setGravity(Gravity.CENTER_VERTICAL);  //中央寄せ「必要！」
        in_layout1.setLayoutParams(new LinearLayout.LayoutParams(WC,WC,1)); //注意！「weight = "1"」
       
        textview = new TextView(this);
        textview.setText("Please click your favorite Country！");
        textview.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
        textview.setTextSize(22);
        textview.setTextColor(Color.rgb(0,0,0));  //
        textview.setPadding(5, 0, 5, 0); //left, top, right, bottom
        textview.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        textview.setGravity(Gravity.CENTER);
        
        //ラジオグループの生成
        radio_group = new RadioGroup(this);
        
        radiobutton = new  RadioButton[array_length]; // ラジオボタン配列の生成
        
        //ラジオボタンへの設定
        for (int i=0; i < radiobutton.length; i++)
        {
        	radiobutton[i] = new RadioButton(this);

        	radiobutton[i].setText(country[i] + " ");  //ラベルの表示 最後の空白「" "」に注意
        	radiobutton[i].setTextColor(Color.rgb(0,0,0));  //
        	radiobutton[i].setTextSize(16);
        	radiobutton[i].setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
        	radiobutton[i].setId(i);
        	radiobutton[i].setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        	radiobutton[i].setOnClickListener(this);
        	radio_group.addView(radiobutton[i]);
        	//in_layout1.addView(radiobutton[i]);  //エラー
        }
        
        radio_group.check(0); //「id = 0」のRadioButtonを「on」にセット
        
        in_layout1.addView(radio_group);
        
        layout.addView(textview, params);  //画面の上端にMarginを付けて配置
        layout.addView(in_layout1);  //BadioButtonを、画面の中央に配置
       //layout.addView(textview, params);  //①画面の下端に配置するとき、最後に記述する！
    }
//
    public void onClick(View view)
    {
    	Integer[] color ={Color.BLUE, Color.RED, Color.YELLOW, Color.CYAN, Color.MAGENTA, Color.GREEN};  //色の配列
    	
    	String[] capital ={"キャンベラ","ロンドン","パリ","ベルリン","ローマ","北京"};

    	int checked_id;
    	
    	checked_id = view.getId(); //クリックしたRadioButtonの「ID」を取得
    	
    	 //クリックしたRadioButtonのクラス「変数」を取得
    	RadioButton radio_button = (RadioButton)findViewById(checked_id);

    	radio_button.setBackgroundColor(color[checked_id]); //クリックしたRadioButtonの背景色を設定
        
   	    textview.setText("首都は " + "[ " + capital[checked_id] + " ]");
   	    
        layout.setBackgroundColor(color[radio_group.getCheckedRadioButtonId()]);  //クリックしたRadioButtonで、画面の背景色を変える
    }
}