package com.sample.android.spinner_test3;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.widget.Spinner;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.view.View;
import android.graphics.Color;

public class Spinner_Test3 extends Activity {
    /** Called when the activity is first created. */
    private final static int WC  = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP  = LinearLayout.LayoutParams.MATCH_PARENT;

	private LinearLayout layout1;

	private TextView tv1;

	private Spinner spinner;
	
	private String[] list_data = { "貴方の好きな果物は何ですか？", "イチゴ", "メロン", "マンゴー", "スイカ","リンゴ","カキ","ナシ","ミカン"};

	private boolean Flag = false;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout1=new LinearLayout(this);
        layout1.setBackgroundColor(Color.rgb(0,0,0));
        layout1.setOrientation(LinearLayout.VERTICAL);
        layout1.setGravity(Gravity.TOP);
        layout1.setGravity(Gravity.CENTER_HORIZONTAL);
        setContentView(layout1);

        tv1 = new TextView(this);
        tv1.setText("\n下のメニューを押して下さい！\n");
        tv1.setTextColor(Color.WHITE);
        tv1.setGravity(Gravity.CENTER_HORIZONTAL);  //表示する文字の中央寄せ
	    tv1.setTextSize(20);
	    tv1.setId(10);
        layout1.addView(tv1, new LinearLayout.LayoutParams(MP, WC));

        spinner = new Spinner(this);
        spinner.setBackgroundColor(Color.BLUE);
        
        ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>( this, android.R.layout.simple_spinner_item, list_data);
        arrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        
        spinner.setAdapter(arrayAdapter);
        
        //リスト項目内の「引数で指定された値 +１」の項目に、カーソルを移動する
        spinner.setSelection(-2);
          //spinner.setPrompt("以下のリストより選択して下さい。");   //Spinner に表示させるプロンプトを設定
        spinner.setScrollContainer(true);   //スクロールバーの表示
        
        spinner.setOnItemSelectedListener( new Clicked_Item_Detected());  //イベント・リスナーの設定
        
        layout1.addView(spinner, new LinearLayout.LayoutParams(WC, WC));
    }

	//ListのItemのクリックされたときのイベント処理をするクラス
	class Clicked_Item_Detected implements OnItemSelectedListener
	{
    	public void onItemSelected(AdapterView<?> parent, View view, int position, long id)
    	{
    	   Spinner spinner = (Spinner) parent;

    	   String item = (String)spinner.getSelectedItem();

    	   if(Flag == true)
    	   {
    	      tv1.setText( "\n私の好きな果物は [ " + item + " ] です！\n");

       	      Toast.makeText(Spinner_Test3.this,String.format("私の好きな果物は %s です！。", item),Toast.LENGTH_LONG).show();
    	   }
    	   
    	   Flag = true;
        }

       public void onNothingSelected(AdapterView<?> parent)
       {
           Toast.makeText(Spinner_Test3.this,"何も選択されていません！",Toast.LENGTH_LONG).show();
       }
    }
}