package com.sample.android.surfaceview_thread1;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.view.SurfaceView;
import android.view.SurfaceHolder;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.MotionEvent;
import android.widget.Toast;

public class SurfaceView_Thread1 extends Activity {
    /** Called when the activity is first created. */

	private  Show_Ball_SurfaceView surface_obj;  //Touch_Showクラス のオブジェクトの宣言
	private SurfaceHolder  holder;

    private Thread  myThread = null;

    private Bitmap  face1, face2, face3, face4, face5;

    private int img_x1 = 100, img_y1 = 100, img_x2 = 100, img_y2 = 100, img_x3 = 100, img_y3 = 100,
    img_x4 = 100, img_y4 = 100, img_x5 = 100, img_y5 = 100;

    private boolean Flag = true;  //表示する画像のStart位置の切り替え用のフラグ

    private int dx1 = 10,  dy1 = 30;	//各画像の(x方向, y方向)の移動量
    private int dx2 = -10, dy2 = -30;
    private int dx3 = -30, dy3 = 10;
    private int dx4 = -10, dy4 = -10;
    private int dx5 = 25,  dy5 = -15;

	private int touch_Action = -999; //Touchアクション
	private boolean change_Flag = true; //Touchイベントでの表示の切り替え用Flag

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        surface_obj = new Show_Ball_SurfaceView(this); //Show_Ball_SurfaceViewクラスを呼ぶ為のクラスオブジェクト
        setContentView(surface_obj);
    }

    // SurfaceViewを描画するクラス
    public class Show_Ball_SurfaceView extends SurfaceView implements SurfaceHolder.Callback, Runnable
    {
        private int Width, Height;

        //コンストラクタ
        public Show_Ball_SurfaceView(Context context)
        {
            super(context);

            //画像の読み込み
            Resources r = getResources();
            face1 = BitmapFactory.decodeResource(r,R.drawable.face1); //iconファイルは不可！
            face2 = BitmapFactory.decodeResource(r,R.drawable.face2);
            face3 = BitmapFactory.decodeResource(r,R.drawable.face3);
            face4 = BitmapFactory.decodeResource(r,R.drawable.face4);
            face5 = BitmapFactory.decodeResource(r,R.drawable.face5);

            //SurfaceViewの生成
            holder = getHolder();     //SurfaceHolderの生成 //getHolder().addCallback(this); も可能！
            holder.addCallback(this); //Callback関数の登録  //getHolder().addCallback(this); も可能！
            holder.setFixedSize(getWidth(), getHeight());  //Surfaceのサイズを設定
        }

        // Touchイベントの処理
        public boolean onTouchEvent(MotionEvent event)
        {
            //[ACTION_DOWN] [ACTION_UP] [ACTION_MOVE] [ACTION_CANCEL]の動きをとらえる事ができる
        	touch_Action = event.getAction();

        	if(touch_Action == MotionEvent.ACTION_DOWN)
   	        {
        		if(change_Flag == true)  //Tuchにより表示のStart
        		{
        		   Toast.makeText(getApplicationContext(), "Start",Toast.LENGTH_SHORT).show();

        		   myThread = new Thread(this);
        		   myThread.start(); //スレッドのスタート！

        		   change_Flag = false;
        		}
        		else  //Tuchにより表示のStop //
        		{
        		   Toast.makeText(getApplicationContext(), "Stop",Toast.LENGTH_SHORT).show();
        		   myThread = null;
        		   change_Flag = true;
        		}
   	        }
            return true;
        }
//
        //サーフェイスの生成  //Touchイベントがないときに使用する！
        public void surfaceCreated(SurfaceHolder holder)
        {
        	//myThread = new Thread(this);
        	//myThread.start();// スレッド開始

            //Canvas canvas = holder.lockCanvas();
            //canvas.drawColor(Color.BLACK);
            //holder.unlockCanvasAndPost(canvas);
        }

        //サーフェイスの変更
        public void surfaceChanged(SurfaceHolder holder, int format, int width,int height)
        {
            // TODO 今回は何もしない。
        }

        //サーフェイスの破棄
        public void surfaceDestroyed(SurfaceHolder holder)
        {
        	 myThread = null;  //スレッドの停止
        }

        //Threadの処理
        public void run()
        {
        	Canvas on_Canvas ; //= holder.lockCanvas();

            Width = getWidth(); Height = getHeight();

            while( myThread != null)  //while(true)
            {
            	on_Canvas = holder.lockCanvas();  //
            	on_Canvas.drawColor(Color.BLACK);  //必要！

            	if( Flag == true ) //Startのときの画像の位置
            	{
            	   on_Canvas.drawBitmap(face1, Width / 2 - 16, Height / 2 - 20 , null);
                   on_Canvas.drawBitmap(face2, Width / 2 - 16, Height / 2 - 20 , null);
                   on_Canvas.drawBitmap(face3, Width / 2 - 16, Height / 2 - 20 , null);
                   on_Canvas.drawBitmap(face4, Width / 2 - 16, Height / 2 - 20 , null);
                   on_Canvas.drawBitmap(face5, Width / 2 - 16, Height / 2 - 20 , null);
                   Flag = false ;  //Startのあとは、この処理をパスする
            	}
//
                // 画像①
         		if(img_x1 >= getWidth() - 32)  dx1 = -dx1;	//右の壁を越えた

         		if(img_y1 >= getHeight() - 32)  dy1 = -dy1;	//下の壁を越えた

         		if(img_x1 <= 0)  dx1 = -dx1;	//左の壁を越えた

         		if(img_y1 <= 0)  dy1 = -dy1;	//上の壁を越えた

         		on_Canvas.drawBitmap(face1,img_x1, img_y1 , null);  //face1の描画

         		img_x1 += dx1;
         		img_y1 += dy1;

         		// 画像②
        		if(img_x2 >= getWidth() - 32)  dx2 = -dx2;	//右の壁を越えた

         		if(img_y2 >= getHeight() - 32)  dy2 = -dy2;	//下の壁を越えた

         		if(img_x2 <= 0)  dx2 = -dx2;	//左の壁を越えた

         		if(img_y2 <= 0)  dy2 = -dy2;	//上の壁を越えた

         		on_Canvas.drawBitmap(face2,img_x2, img_y2 , null);  //face2の描画

         		img_x2 += dx2;
         		img_y2 += dy2;

         		// 画像③
        		if(img_x3 >= getWidth() - 32)  dx3 = -dx3;	//右の壁を越えた

         		if(img_y3 >= getHeight() - 32)  dy3 = -dy3;	//下の壁を越えた

         		if(img_x3 <= 0)  dx3 = -dx3;	//左の壁を越えた

         		if(img_y3 <= 0)  dy3 = -dy3;	//上の壁を越えた

         		on_Canvas.drawBitmap(face3,img_x3, img_y3, null);  //face3の描画

         		img_x3 += dx3;
         		img_y3 += dy3;

         		// 画像④
        		if(img_x4 >= getWidth() - 32)  dx4 = -dx4;	//右の壁を越えた

         		if(img_y4 >= getHeight() - 32)  dy4 = -dy4;	//下の壁を越えた

         		if(img_x4 <= 0)  dx4 = -dx4;	//左の壁を越えた

         		if(img_y4 <= 0)  dy4 = -dy4;	//上の壁を越えた

         		on_Canvas.drawBitmap(face4,img_x4, img_y4 , null);  //face4の描画

         		img_x4 += dx4;
         		img_y4 += dy4;

         		// 画像⑤
        		if(img_x5 >= getWidth() - 32)  dx5 = -dx5;	//右の壁を越えた

         		if(img_y5 >= getHeight() - 32)  dy5 = -dy5;	//下の壁を越えた

         		if(img_x5 <= 0)  dx5 = -dx5;	//左の壁を越えた

         		if(img_y5 <= 0)  dy5 = -dy5;	//上の壁を越えた

         		on_Canvas.drawBitmap(face5,img_x5, img_y5 , null);  //face5の描画

         		img_x5 += dx5;
         		img_y5 += dy5;

                holder.unlockCanvasAndPost(on_Canvas);  //[ drawBitmap ]のあとに配置しないと、前のイメージが消されない！

                try{
                    Thread.sleep(150); //try{}catch{}が必要！
                }catch(Exception e)
                {
                	Toast.makeText(getApplicationContext(), "エラー： " + e ,Toast.LENGTH_SHORT).show();
                }
            } //while()
        } //run()
    }
}
