package com.sample.android.location_test1;

import java.util.Date;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationProvider;
import android.location.LocationManager;
import android.view.Gravity;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.util.Log;

public class Location_Test1 extends Activity implements LocationListener{
    /** Called when the activity is first created. OnClickListener, */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout;

	private TextView text1;
    private LocationManager lcation_manager; //
    private Location location;

    private String best_provider;

    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.RED);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("緯度：経度の表示");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        lcation_manager = (LocationManager)getSystemService(LOCATION_SERVICE);
        
        if(lcation_manager == null){ return; }
    }
//
    protected void onResume()
    {
        super.onResume();

        //現在の状況に最適なプロバイダ (GPS[gpsで取得] : 3G[networkで取得] : Wi-Fi[networkで取得])を取得する
        best_provider = lcation_manager.getBestProvider(new Criteria(), true);
        //provider = lcation_manager.NETWORK_PROVIDER;
        //provider = lcation_manager.getProviders(true);

        if(best_provider == null)
        {
            //位置情報が取得できるプロバイダがないとき (GPS[gpsで取得] : 3G[networkで取得] : Wi-Fi[networkで取得])
        	Toast.makeText(getApplicationContext(), "位置情報が取得できるプロバイダがありません",Toast.LENGTH_SHORT).show();
        	return;
        }
        else{
        	Toast.makeText(getApplicationContext(), "位置情報が取得できるプロバイダ OK !",Toast.LENGTH_SHORT).show();
        	Toast.makeText(getApplicationContext(), "provider = " + best_provider ,Toast.LENGTH_SHORT).show();
        }

        //GPS となっている
        lcation_manager.requestLocationUpdates(best_provider, 0, 0, this);  //GPS となっている
        //lcation_manager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, this);

        // 最後に取得した位置情報を取得
        location = lcation_manager.getLastKnownLocation(best_provider);

        if( location == null )
        {
        	Toast.makeText(getApplicationContext(), "provider = " + "GPS_PROVIDER" ,Toast.LENGTH_LONG).show();
        	lcation_manager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
        	onLocationChanged(location);
        }
        
        if( location == null )
        {
        	Toast.makeText(getApplicationContext(), "provider = " + "NETWORK_PROVIDER" ,Toast.LENGTH_LONG).show();
        	lcation_manager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER); 
        }
        
        
        if (location != null)
        {
        	//onLocationChanged()メソッドを呼ぶ
        	onLocationChanged(location);

        	Toast.makeText(getApplicationContext(), "onLocationChanged を呼ぶ！",Toast.LENGTH_SHORT).show();
        }else{
        	Toast.makeText(getApplicationContext(), "location = null です！",Toast.LENGTH_SHORT).show();
        	return;
        }
    }

    // 位置情報が変化したとき呼び出される
    public void onLocationChanged(Location location)
    {
        double latitude  = location.getLatitude();
        double longitude = location.getLongitude();

        Date date = new Date(location.getTime());

        text1.setText("Best_Provider = " + best_provider + "\n\n緯度 = " + latitude + "\n経度 = " + longitude + "\n\nDate : " + date);
    }

    public void onPause()
    {
        super.onPause();

        // リスナーを解除
        lcation_manager.removeUpdates(this);
    }

    // プロバイダが有効になったとき呼ばれる
    public void onProviderEnabled(String provider)
    {
    	//
    }

    // プロバイダが無効になったとき呼ばれる
    public void onProviderDisabled(String provider)
    {
    	//
    }

    // プロバイダの状態が変化したとき呼ばれる
    public void onStatusChanged(String provider, int status, Bundle extras)
    {
        switch (status)
        {
           case LocationProvider.AVAILABLE:
               Log.v("Status", "AVAILABLE");
               break;
           case LocationProvider.OUT_OF_SERVICE:
               Log.v("Status", "OUT_OF_SERVICE");
               break;
           case LocationProvider.TEMPORARILY_UNAVAILABLE:
                Log.v("Status", "TEMPORARILY_UNAVAILABLE");
                break;
        }
    }
}