package com.sample.android.thread_double_buffer8;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Rect;
import android.view.Gravity;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.widget.Toast;

public class Thread_Double_Buffer8 extends Activity implements View.OnClickListener {
    /** Called when the activity is first created. */
	
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout;
	private Button button1;
	private TextView tv;

	private  Show_SurfaceView surface_obj;  //Touch_Showクラス のオブジェクトの宣言
	private SurfaceHolder  holder;

    private Thread  myThread;

    private Canvas on_Canvas;
    private Canvas off_Canvas; //オフ・スクリーン用

    private Bitmap  off_Screen_Buffer; //画像を表示するときのダブルバッファ用のバッファ・メモリの確保用
    private Bitmap  chyo1, chyo2, l_up_chyo1, l_up_chyo2, r_down_chyo1, r_down_chyo2, l_down_chyo1, l_down_chyo2,
                    back_jpeg2;

    private boolean Flag = true;  //蝶の「開いた羽」と「閉じた羽」の切り替え用のフラグ

    private int x = 80, y = 80;
    private int dx = 20, dy = -20;
    private int n = 3;

    private int back_Width, back_Height;
    private Rect source1, destination1;
    
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,0));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER); //中央寄せ
        setContentView(layout); //レイアウトの生成

 //直接、Show_SurfaceViewクラスを呼ぶとき、次の2行をここで設定する。このときButtonとイベントを削除する
        //surface_obj = new Show_SurfaceView(this); //Touch_Showクラスを呼ぶ為のクラスオブジェクト
        //setContentView(surface_obj);
        //surface_obj = new Show_SurfaceView(this); //Touch_Showクラスを呼ぶ為のクラスオブジェクト
        //setContentView(surface_obj);
        
        tv = new TextView(this);
        tv.setText("[ Start ] ボタンをクリックしたあと、次の[ 黒い画面 ]のクリックを繰り返して下さい！");
        tv.setTextColor(Color.BLUE);
        tv.setTextSize(18);  //tv.setTypeface(tf);
        layout.addView(tv, new LinearLayout.LayoutParams(WC, WC));

        button1 = new Button(this);
        button1.setText("Start");   button1.setTextColor(Color.BLACK);
        button1.setBackgroundColor(Color.RED);
        button1.setOnClickListener(this);
        layout.addView(button1,new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        surface_obj = new Show_SurfaceView(this); //Touch_Showクラスを呼ぶ為のクラスオブジェクト
        setContentView(surface_obj);
    }

    class Show_SurfaceView extends  SurfaceView implements SurfaceHolder.Callback,Runnable
    {
    	private int touch_Action = -999; //タッチアクション
    	private boolean change_Flag = true;

       //コンストラクタ
        public Show_SurfaceView(Context context)
        {
            super(context);

            //画像の読み込み
            Resources r =getResources();
            chyo1 = BitmapFactory.decodeResource(r,R.drawable.bfly1);
            chyo2 = BitmapFactory.decodeResource(r,R.drawable.bfly2);
            l_up_chyo1 = BitmapFactory.decodeResource(r,R.drawable.hidariue1);
            l_up_chyo2 = BitmapFactory.decodeResource(r,R.drawable.hidariue2);

            r_down_chyo1 = BitmapFactory.decodeResource(r,R.drawable.migishita1);
            r_down_chyo2 = BitmapFactory.decodeResource(r,R.drawable.migishita2);

            l_down_chyo1 = BitmapFactory.decodeResource(r,R.drawable.hidarishita1);
            l_down_chyo2 = BitmapFactory.decodeResource(r,R.drawable.hidarishita2);

            back_jpeg2 = BitmapFactory.decodeResource(r,R.drawable.zamami1); //背景の画像
            
            holder = getHolder(); //「SurfaceHolder」を取得する
            holder.addCallback(this); //「SurfaceHolder」にコールバックを設定して、コールバック内で描画を行う！
            holder.setFixedSize(getWidth(), getHeight());
         }

        //タッチイベントの処理
        public boolean onTouchEvent(MotionEvent event)
        {
            back_Width = back_jpeg2.getWidth(); //写真の大きさの取得
            back_Height = back_jpeg2.getHeight();
            
            source1 = new Rect(0,0,back_Width, back_Height);  //元の写真の大きさを取得する！
            destination1 = new Rect(0,0,getWidth(), getHeight());  //表示端末の画面の大きさを取得する！
            
        	touch_Action = event.getAction();

        	if(touch_Action == MotionEvent.ACTION_DOWN)
   	        {
        		if(change_Flag == true)
        		{
        		   Toast.makeText(getApplicationContext(), "Start",Toast.LENGTH_SHORT).show();
        		   myThread = new Thread(this);
        		   myThread.start(); //スレッドのスタート！

        		   change_Flag = false;
        		}
        		else
        		{
        		   Toast.makeText(getApplicationContext(), "Stop",Toast.LENGTH_SHORT).show();
        		   myThread = null;
        		   change_Flag = true;
        		}
   	        }

    	    return true;
       }

        public void surfaceCreated(SurfaceHolder  holder)
        {
            //myThread = new Thread(this);
            //run()メソッドが、この「start()」メソッドにより並列プロセスとして呼び出される
            //myThread.start(); //スレッドのスタート！
        }

        public void surfaceDestroyed(SurfaceHolder  holder)
        {
            myThread = null;
        }

        public void surfaceChanged(SurfaceHolder holder, int format, int w, int h)
        {
        	//特別な処理はなし！
        }

        public void run()
        {
            // オフスクリーン
            while (myThread != null)
            {
                on_Canvas = holder.lockCanvas(); //Canvasを取得し、ここで取得したキャンバスに自由に描画する

                //オフ・スクリーン用の バッファを取得する
                off_Screen_Buffer = Bitmap.createBitmap(on_Canvas.getWidth(), on_Canvas.getHeight(),Bitmap.Config.ARGB_8888);

                off_Canvas = new Canvas(off_Screen_Buffer); //オフ・スクリーン用の「Canvas」
                off_Canvas.setBitmap(off_Screen_Buffer);  //off_Canvasに描画する

                    x = x + dx;	//←x=50;   dx=20;
                    y = y + dy;	//←y=180;  dy=-20;

                    if(Flag == true){ Flag = false; }else{ Flag = true; }

                    if (y < -20)	//←画面の上の壁にあたったとき
                    {
                        if (dx > 0)	//←蝶が右に進行中
                        {
                            dy = -dy;
                            n = 0;	//←蝶を右下に進行させる
                        }
                        else	//←蝶が左に進行中
                        {
                            dy = -dy;
                            n = 2;	//←蝶を左下に進行させる
                        }
                    }

                    if (x  > getWidth() + 20)	//←画面の右の壁にあたったとき
                    {
                        if (dy > 0)	//←蝶が下に進行中
                        {
                            dx = -dx;
                            n = 2;	//←蝶を左下に進行させる
                        }
                        else	//←蝶が上に進行中
                        {
                            dx = -dx;
                            n = 1;	//←蝶を左上に進行させる
                        }
                    }

                    if (y > getHeight() + 10)	//←画面の下の壁にあたったとき getSize().height
                    {
                        if (dx > 0)	//←蝶が右に進行中
                        {
                            dy = -dy;
                            n = 3;	//←蝶を右上に進行させる
                        }
                        else	//←蝶が左に進行中
                        {
                            dy = -dy;
                            n = 1;	//←蝶を左上に進行させる
                        }
                    }

                    if (x < -20)	//←画面の左の壁にあたったとき
                    {
                        if (dy > 0)	//←蝶が下に進行中
                        {
                            dx = -dx;
                            n = 0;	//←蝶を右下に進行させる
                        }
                        else	//←蝶が上に進行中
                        {
                            dx = -dx;
                            n = 3;	//←蝶を右上に進行させる
                        }
                    }

                    if (Flag == true)	//羽が開いた状態
                    {
                        switch (n)
                        {
                            case 0:	//OffScreenへの描画
                            	off_Canvas.drawBitmap(r_down_chyo1,x,y,null);
                                break;	//←右下に進行
                            case 1:
                            	off_Canvas.drawBitmap(l_up_chyo1,x,y,null);
                                break;	//←左上に進行
                            case 2:
                            	off_Canvas.drawBitmap(l_down_chyo1,x,y,null);
                                break;	//←左下に進行
                            case 3:
                            	off_Canvas.drawBitmap(chyo1,x,y,null);
                                break;	//←右上に進行
                        }
                    }
                    else	//羽が閉じた状態
                    {
                        switch (n)
                        {
                           case 0:	//←OffScreenへ表示
                        	   off_Canvas.drawBitmap(r_down_chyo2,x ,y,null);
                               break;	//←右下に進行
                           case 1:
                        	   off_Canvas.drawBitmap(l_up_chyo2,x ,y,null);
                               break;	//←左上に進行
                           case 2:
                        	   off_Canvas.drawBitmap(l_down_chyo2,x ,y,null);
                               break;	//←左下に進行
                           case 3:
                        	   off_Canvas.drawBitmap(chyo2,x ,y,null);
                               break;	//←右上に進行
                        }
                    }

                on_Canvas.drawBitmap(back_jpeg2, source1, destination1, null);
                on_Canvas.drawBitmap(off_Screen_Buffer, 0, 0, null); //On_Screenへの描画

                //最後に、SurfaceHolderのunlockCanvasAndPost(Canvas)を呼び出して描画を完了する
                holder.unlockCanvasAndPost(on_Canvas);

                try{
                	Thread.sleep(100); //try{}catch{}が必要！
                }catch(Exception e){
                }
            }
        }
    }
}