package com.sample.android.touch_event1;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.view.View;
import android.view.MotionEvent;
import android.graphics.Color;
import android.graphics.Canvas;
import android.graphics.Paint;

public class Touch_Event1 extends Activity {
    /** Called when the activity is first created. */
	
	private Touch_Show touch_obj;  //Touch_Showクラス のオブジェクトの宣言
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        touch_obj = new Touch_Show(this); //Touch_Showクラスを呼ぶ為のクラスオブジェクト
        setContentView(touch_obj);
    }
    
    class Touch_Show extends View 
    {
        private int touch_x = 0;        //画面をタッチした時のX座標
        private int touch_y = 0;        //画面をタッチした時のY座標
        
        private int touch_Action = -999; //タッチアクション
        
        private int ball_x = 0;         //トラックボールのX座標
        private int ball_y = 0;         //トラックボールのY座標
        //private int ball_Action =- 999; //ボールアクション
        
        private Paint paint1;

    	private static final int CIRCLE = 10; //表示する円の半径
    	
    	Touch_Show(Context context)  //コンストラクタ
    	{
    	   super(context);
    	   setBackgroundColor(Color.YELLOW);

           setFocusable(true); //フォーカスの設定
        }
    	
    	//タッチイベントの処理
        public boolean onTouchEvent(MotionEvent event)
        {
        	touch_Action = event.getAction();  //Actionの取得
            
   	        if(touch_Action == MotionEvent.ACTION_DOWN)
   	        { 
          	    touch_x = (int) event.getX();
        	    touch_y = (int) event.getY();
   	        }

 	        if(touch_Action==MotionEvent.ACTION_MOVE)
 	        {
 	        	touch_x = (int) event.getX();
 	        	touch_y = (int) event.getY();
 	        }

 	        if(touch_Action==MotionEvent.ACTION_UP)
 	        {
   	    	    touch_x = (int) event.getX();
        	    touch_y = (int) event.getY();
 	        }

           invalidate(); //ビューの再描画
    	   return true;
       }
        
       //トラックボールのイベントの処理
       public boolean onTrackballEvent(MotionEvent event)
       {
            ball_x = (int)(event.getX()*100);
            ball_y = (int)(event.getY()*100);

            return true;
       }
       
       //描画の処理
       protected void onDraw(Canvas canvas)
       {
    	    paint1 = new Paint();
    	   
    	    paint1.setAntiAlias(true);
    	    paint1.setColor(Color.rgb(255, 0, 0));
    	    canvas.drawCircle(touch_x, touch_y, CIRCLE, paint1);  //円の描画
    	   
    	    paint1.setColor(Color.rgb(0, 0, 0));  //Touch位置の表示
 	        canvas.drawText("(" + touch_x + " , " + touch_y + ")",touch_x + 12 , touch_y + 5, paint1);
 	       
    	    paint1.setColor(Color.rgb(255, 0, 0));  //トラックボールの位置の表示
 	        canvas.drawText("(" + ball_x + " , " + ball_y + ")",getWidth() / 2 , getHeight() / 2, paint1);

 	        invalidate(); //ビューの再描画
       }
    }
}